/* 
 *   Creation Date: <1999/02/22 22:46:22 samuel>
 *   Time-stamp: <2002/11/16 16:48:56 samuel>
 *   
 *	<debugger.h>
 *	
 *	World interface of the debugger
 *   
 *   Copyright (C) 1999, 2000, 2001, 2002 Samuel Rydh (samuel@ibrium.se)
 *   
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License
 *   as published by the Free Software Foundation
 *   
 */

#ifndef _H_DEBUGGER
#define _H_DEBUGGER

#include <sys/types.h>

extern void 	debugger_init( void );
extern void 	debugger_cleanup( void );

extern int	debugger_enabled( void );
extern int	debugger_attached( void );

/*******************************************/
/*	montior.c / nub.c		   */
/*******************************************/

extern void 	refresh_debugger_window( void );
extern void 	refresh_debugger( void );
extern void 	redraw_inst_win( void );
extern int	debugger_in_68k_mode( void );
extern void	debugger_nub_poll( void );

/* debug actions */
enum{  
	kDbgNOP=0, kDbgGo, kDbgGoRFI, kDbgStep, kDbgExit, kDbgStop, kDbgGoUser
};


/*******************************************/
/*	cmdline.c / nub.c		   */
/*******************************************/

/* put functions used exclusively in debugger mode in the dbg section */
#define __dbg	__attribute__ ((__section__ (".moldbg")))

extern int	printm(const char *fmt,...)
                __attribute__ ((format (printf, 1, 2)));

extern int	logprint(const char *fmt,... )
                __attribute__ ((format (printf, 1, 2)));

extern int	async_print(const char *fmt,... )
                __attribute__ ((format (printf, 1, 2)));

typedef int (*dbg_cmd_fp)( int argv, char **argc );
extern void	add_cmd( char *cmdname, char *help, int dummy, dbg_cmd_fp func );

/* for debugging */
#define HARD_BREAKPOINT \
	({ printm("Hardcoded breakpoint in '"__FILE__"'\n"); stop_emulation(); })

#endif   /* _H_DEBUGGER */
